import pandas as pd
from datetime import datetime
import numpy as np
from datetime import timedelta

df = pd.read_csv('private_data.csv', sep='|')
print(df.head())

df.drop(columns=["name","phone"], inplace=True)

print("Generalize address to 5-digit ZIP Code and drop the address field")
df["zip"] = df["address"].str[-5:]
# df["zip"] = df["address"].str.split(' ').str[-1]
df.drop(columns="address", inplace=True)
print(df.head())

study_date = datetime(2024, 1, 1)
np.random.seed(123)
random_years = np.random.randint(low=1, high=4, size=100)
df["birthdate"] = pd.to_datetime(df["birthdate"])
study_date - df["birthdate"]
(study_date - df["birthdate"])/timedelta(365)
round((study_date - df["birthdate"])/timedelta(365)) + random_years
df["age"] = round((study_date - pd.to_datetime(df["birthdate"]))/timedelta(365)) + random_years
df.drop(columns="birthdate", inplace=True)
print(df.head())

import hmac
import hashlib

secret_key = '123abc'
message = 'my private data'

hmac.new(
    bytes(secret_key, 'latin-1'),
    msg=bytes(message, 'latin-1'),
    digestmod=hashlib.sha256
)
hmac.new(
    bytes(secret_key, 'latin-1'),
    msg=bytes(message, 'latin-1'),
    digestmod=hashlib.sha256
).hexdigest()

with open("lab2/secret.txt") as f:
    secret_key = f.readline().strip()
    
df["id"] = df["ssn"].apply(
    lambda x: 
        hmac.new(
            bytes(secret_key, 'latin-1'), 
            msg=bytes(x, 'latin-1'), 
            digestmod=hashlib.sha256
            ).hexdigest())

df.drop(columns="ssn", inplace=True)
df.to_csv("lab2/deidentified_data.csv")
print(df)
